#include <iostream>
#include <vector>
#include <stack>
#include <queue>

using namespace std;

vector<int> euler(vector< vector<int> > graf) {

	deque<int> tour;
	stack<int> s;
	s.push(0);

	while(!s.empty()) {
		int v = s.top();
		
		if(graf[v].empty()) {
			tour.push_front(v);
			s.pop();
			continue;
		}

		s.push(graf[v].back());
		graf[v].pop_back();
	}

	return vector<int>(tour.begin(), tour.end());
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;

		graf[u].push_back(v);
	}

	vector<int> tour = euler(graf);
	
	for(int u : tour)
		cout << u << ' ';
	cout << '\n';

	return 0;
}
