#include <iostream>
#include <vector>
#include <stack>
#include <queue>

using namespace std;

// Problem: O(m) memorijska slozenost na stek
void euler(int u, deque<int>& ciklus, vector< vector<int> >& graf) {
	while(!graf[u].empty()) {
		int v = graf[u].back();
		graf[u].pop_back();

		euler(v, ciklus, graf);
	}
	ciklus.push_front(u);
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;

		graf[u].push_back(v);
	}

	deque<int> ciklus;
	euler(0, ciklus, graf);

	vector<int> tour(ciklus.begin(), ciklus.end());

	for(int x : tour)
		cout << x << ' ';
	cout << '\n';

	return 0;
}
