#include <iostream>
#include <vector>
#include <stack>

using namespace std;

// O(n^2)
vector<int> euler(vector< vector<int> > graf) {
	int n = graf.size();

	vector< vector<bool> > edge(n, vector<bool>(n));
	for(int u = 0; u < n; u++)
		for(int v : graf[u])
			edge[u][v] = true;

	vector<int> tour;
	stack<int> s;
	s.push(0);

	while(!s.empty()) {
		int v = s.top();

		while(!graf[v].empty() && !edge[v][graf[v].back()])
			graf[v].pop_back();
		
		if(graf[v].empty()) {
			tour.push_back(v);
			s.pop();
			continue;
		}

		edge[v][graf[v].back()] = edge[graf[v].back()][v] = false;
		s.push(graf[v].back());
		graf[v].pop_back();
	}

	return tour;
}

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<int> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;

		graf[u].push_back(v);
		graf[v].push_back(u);
	}

	vector<int> tour = euler(graf);
	
	for(int u : tour)
		cout << u << ' ';
	cout << '\n';

	return 0;
}
