#include <iostream>
#include <vector>
#include <set>
#include <limits>
#include <tuple>
#include <algorithm>

using namespace std;

using edge = pair<int, int>; // (sused, duzina)

vector<edge> prim(vector< vector<edge> >& graf) {
	int n = graf.size();

	vector<edge> grana(n, {-1, numeric_limits<int>::max()});
	vector<int> dodat(n, false);
	set< pair<int, int> > pq;

	pq.insert({0, 0});

	while(!pq.empty()) {
		int v = pq.begin()->second;
		pq.erase(pq.begin());
		dodat[v] = true;

		for(auto e : graf[v]) {
			int w = e.first, duzina = e.second; // (sused, duzina)
			if(!dodat[w] && duzina < grana[w].second) {
				pq.erase({grana[w].second, w});
				grana[w] = {v, duzina};
				pq.insert({grana[w].second, w});
			}
		}
	}

	return grana;
}

/*

Primer:
5 7
0 4 2
0 2 3
4 2 1
2 1 3
0 1 4
1 3 5
0 3 4

*/

int main() {
	int n, m;
	cin >> n >> m;

	vector< vector<edge> > graf(n);
	for(int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		graf[u].push_back({v, w});
		graf[v].push_back({u, w});
	}

	vector<edge> stablo = prim(graf);

	int mst = 0;
	for(int u = 0; u < n; u++) {
		cout << u << ' ' << stablo[u].first << '\n';
		if(stablo[u].first != -1)
			mst += stablo[u].second;
	}

	cout << mst << '\n';

	return 0;
}
